*** a/src/backend/utils/mmgr/portalmem.c
--- b/src/backend/utils/mmgr/portalmem.c
***************
*** 25,30 ****
--- 25,31 ----
  #include "utils/builtins.h"
  #include "utils/memutils.h"
  #include "utils/timestamp.h"
+ #include "storage/proc.h"
  
  /*
   * Estimate of the maximum number of open portals a user would have,
***************
*** 724,729 **** PreCommit_Portals(bool isPrepare)
--- 725,839 ----
  }
  
  /*
+  * Pre-commit processing for portals in Autonomous Transaction.
+  *
+  * Holdable cursors created in this transaction need to be converted to
+  * materialized form, since we are going to close down the executor and
+  * release locks.  Non-holdable portals created in this transaction are
+  * simply removed.	Portals remaining from prior transactions should be
+  * left untouched.
+  *
+  * Returns TRUE if any portals changed state (possibly causing user-defined
+  * code to be run), FALSE if not.
+  */
+ bool
+ AutoPreCommit_Portals(uint32 createSubid)
+ {
+ 	bool		result = false;
+ 	HASH_SEQ_STATUS status;
+ 	PortalHashEnt *hentry;
+ 
+ 	hash_seq_init(&status, PortalHashTable);
+ 
+ 	while ((hentry = (PortalHashEnt *) hash_seq_search(&status)) != NULL)
+ 	{
+ 		Portal		portal = hentry->portal;
+ 
+ 		/* portal created in auto TX? */
+ 		if (createSubid > portal->createSubid)
+ 			continue;
+ 
+ 		/*
+ 		 * There should be no pinned portals anymore. Complain if someone
+ 		 * leaked one.
+ 		 */
+ 		if (portal->portalPinned)
+ 			ereport(ERROR,(errmsg("cannot commit while a portal is pinned")));
+ 
+ 		/*
+ 		 * Do not touch active portals --- this can only happen in the case of
+ 		 * a multi-transaction utility command, such as VACUUM.
+ 		 *
+ 		 * Note however that any resource owner attached to such a portal is
+ 		 * still going to go away, so don't leave a dangling pointer.
+ 		 */
+ 		if (portal->status == PORTAL_ACTIVE )
+ 		{
+ 			portal->resowner = NULL;
+ 			continue;
+ 		}
+ 
+ 		/* Is it a holdable portal created in the auto xact? */
+ 		if ((portal->cursorOptions & CURSOR_OPT_HOLD) &&
+ 			portal->createSubid != InvalidSubTransactionId &&
+ 			portal->status == PORTAL_READY)
+ 		{
+ 			/*
+ 			 * Note that PersistHoldablePortal() must release all resources
+ 			 * used by the portal that are local to the creating transaction.
+ 			 */
+ 			PortalCreateHoldStore(portal);
+ 			PersistHoldablePortal(portal);
+ 
+ 			/* drop cached plan reference, if any */
+ 			PortalReleaseCachedPlan(portal);
+ 
+ 			/*
+ 			 * Any resources belonging to the portal will be released in the
+ 			 * upcoming transaction-wide cleanup; the portal will no longer
+ 			 * have its own resources.
+ 			 */
+ 			portal->resowner = NULL;
+ 
+ 			/*
+ 			 * Having successfully exported the holdable cursor, mark it as
+ 			 * not belonging to this transaction.
+ 			 */
+ 			portal->createSubid = InvalidSubTransactionId;
+ 
+ 			/* Report we changed state */
+ 			result = true;
+ 		}
+ 		else if (portal->createSubid == InvalidSubTransactionId)
+ 		{
+ 			/*
+ 			 * Do nothing to cursors held over from a previous transaction
+ 			 * (including ones we just froze in a previous cycle of this loop)
+ 			 */
+ 			continue;
+ 		}
+ 		else
+ 		{
+ 			/* Zap all non-holdable portals */
+ 			PortalDrop(portal, true);
+ 
+ 			/* Report we changed state */
+ 			result = true;
+ 		}
+ 
+ 		/*
+ 		 * After either freezing or dropping a portal, we have to restart the
+ 		 * iteration, because we could have invoked user-defined code that
+ 		 * caused a drop of the next portal in the hash chain.
+ 		 */
+ 		hash_seq_term(&status);
+ 		hash_seq_init(&status, PortalHashTable);
+ 	}
+ 
+ 	return result;
+ }
+ 
+ /*
   * Abort processing for portals.
   *
   * At this point we reset "active" status and run the cleanup hook if
*** a/src/backend/utils/resowner/resowner.c
--- b/src/backend/utils/resowner/resowner.c
***************
*** 103,108 **** typedef struct ResourceOwnerData
--- 103,110 ----
  	int			ndsms;			/* number of owned shmem segments */
  	dsm_segment **dsms;			/* dynamically allocated array */
  	int			maxdsms;		/* currently allocated array size */
+ 
+ 	uint8		inAutoTXLevel;
  }	ResourceOwnerData;
  
  
***************
*** 1339,1341 **** PrintDSMLeakWarning(dsm_segment *seg)
--- 1341,1351 ----
  		 "dynamic shared memory leak: segment %u still referenced",
  		 dsm_segment_handle(seg));
  }
+ 
+ uint8
+ GetCurrentResourceOwnerAutoTXLevel()
+ {
+ 	Assert(CurrentResourceOwner != NULL);
+ 
+ 	return CurrentResourceOwner->inAutoTXLevel;
+ }
*** a/src/include/access/transam.h
--- b/src/include/access/transam.h
***************
*** 163,169 **** extern TransactionId TransactionIdLatest(TransactionId mainxid,
  extern XLogRecPtr TransactionIdGetCommitLSN(TransactionId xid);
  
  /* in transam/varsup.c */
! extern TransactionId GetNewTransactionId(bool isSubXact);
  extern TransactionId ReadNewTransactionId(void);
  extern void SetTransactionIdLimit(TransactionId oldest_datfrozenxid,
  					  Oid oldest_datoid);
--- 163,170 ----
  extern XLogRecPtr TransactionIdGetCommitLSN(TransactionId xid);
  
  /* in transam/varsup.c */
! TransactionId GetNewTransactionId(bool isSubXact, int stateNestinglevel,
! 															int autotxlevel);
  extern TransactionId ReadNewTransactionId(void);
  extern void SetTransactionIdLimit(TransactionId oldest_datfrozenxid,
  					  Oid oldest_datoid);
*** a/src/include/access/xact.h
--- b/src/include/access/xact.h
***************
*** 27,32 ****
--- 27,38 ----
  #define XACT_REPEATABLE_READ	2
  #define XACT_SERIALIZABLE		3
  
+ #define IS_TOP_AUTO_TX_STATE(s) \
+ 	( \
+ 		((s)->blockState >= TBLOCK_AUTOBEGIN) \
+ 		&& ((s)->blockState <=  TBLOCK_AUTOABORT_PENDING) \
+ 	)
+ 
  extern int	DefaultXactIsoLevel;
  extern PGDLLIMPORT int XactIsoLevel;
  
***************
*** 258,261 **** extern int	xactGetCommittedChildren(TransactionId **ptr);
--- 264,277 ----
  extern void xact_redo(XLogRecPtr lsn, XLogRecord *record);
  extern void xact_desc(StringInfo buf, uint8 xl_info, char *rec);
  
+ extern void DefineAutonomousTransaction(void);
+ extern void BeginInternalAutonomousTransaction(void);
+ extern void CommitInternalAutonomousTransaction(void);
+ extern void AbortInternalAutonomousTransaction(void);
+ extern void BeginAutonomousTransaction(void);
+ extern void CommitAutonomousTransaction(void);
+ extern void AbortAutonomousTransaction(void);
+ extern bool IsCurrentAutoTx(void);
+ 
+ 
  #endif   /* XACT_H */
*** a/src/include/catalog/namespace.h
--- b/src/include/catalog/namespace.h
***************
*** 141,146 **** extern Oid	FindDefaultConversionProc(int32 for_encoding, int32 to_encoding);
--- 141,148 ----
  /* initialization & transaction cleanup code */
  extern void InitializeSearchPath(void);
  extern void AtEOXact_Namespace(bool isCommit);
+ extern void AtEOAutoXact_Namespace(bool isCommit, SubTransactionId mySubid,
+ 					  SubTransactionId parentSubid);
  extern void AtEOSubXact_Namespace(bool isCommit, SubTransactionId mySubid,
  					  SubTransactionId parentSubid);
  
*** a/src/include/commands/trigger.h
--- b/src/include/commands/trigger.h
***************
*** 185,190 **** extern void AfterTriggerBeginXact(void);
--- 185,191 ----
  extern void AfterTriggerBeginQuery(void);
  extern void AfterTriggerEndQuery(EState *estate);
  extern void AfterTriggerFireDeferred(void);
+ extern void AfterTriggerFireDeferredForAutoX(void);
  extern void AfterTriggerEndXact(bool isCommit);
  extern void AfterTriggerBeginSubXact(void);
  extern void AfterTriggerEndSubXact(bool isCommit);
*** a/src/include/nodes/parsenodes.h
--- b/src/include/nodes/parsenodes.h
***************
*** 2356,2362 **** typedef enum TransactionStmtKind
  	TRANS_STMT_ROLLBACK_TO,
  	TRANS_STMT_PREPARE,
  	TRANS_STMT_COMMIT_PREPARED,
! 	TRANS_STMT_ROLLBACK_PREPARED
  } TransactionStmtKind;
  
  typedef struct TransactionStmt
--- 2356,2363 ----
  	TRANS_STMT_ROLLBACK_TO,
  	TRANS_STMT_PREPARE,
  	TRANS_STMT_COMMIT_PREPARED,
! 	TRANS_STMT_ROLLBACK_PREPARED,
! 	TRANS_STMT_AUTONOMOUS
  } TransactionStmtKind;
  
  typedef struct TransactionStmt
*** a/src/include/parser/kwlist.h
--- b/src/include/parser/kwlist.h
***************
*** 51,56 **** PG_KEYWORD("asymmetric", ASYMMETRIC, RESERVED_KEYWORD)
--- 51,57 ----
  PG_KEYWORD("at", AT, UNRESERVED_KEYWORD)
  PG_KEYWORD("attribute", ATTRIBUTE, UNRESERVED_KEYWORD)
  PG_KEYWORD("authorization", AUTHORIZATION, TYPE_FUNC_NAME_KEYWORD)
+ PG_KEYWORD("autonomous_transaction", AUTONOMOUS_TRANSACTION, UNRESERVED_KEYWORD)
  PG_KEYWORD("backward", BACKWARD, UNRESERVED_KEYWORD)
  PG_KEYWORD("before", BEFORE, UNRESERVED_KEYWORD)
  PG_KEYWORD("begin", BEGIN_P, UNRESERVED_KEYWORD)
***************
*** 285,290 **** PG_KEYWORD("password", PASSWORD, UNRESERVED_KEYWORD)
--- 286,292 ----
  PG_KEYWORD("placing", PLACING, RESERVED_KEYWORD)
  PG_KEYWORD("plans", PLANS, UNRESERVED_KEYWORD)
  PG_KEYWORD("position", POSITION, COL_NAME_KEYWORD)
+ PG_KEYWORD("pragma", PRAGMA, UNRESERVED_KEYWORD)
  PG_KEYWORD("preceding", PRECEDING, UNRESERVED_KEYWORD)
  PG_KEYWORD("precision", PRECISION, COL_NAME_KEYWORD)
  PG_KEYWORD("prepare", PREPARE, UNRESERVED_KEYWORD)
*** a/src/include/storage/lock.h
--- b/src/include/storage/lock.h
***************
*** 77,82 **** typedef struct
--- 77,83 ----
  	((vxid).backendId = (proc).backendId, \
  	 (vxid).localTransactionId = (proc).lxid)
  
+ #define     MAX_AUTOX_NESTING_LEVEL   3
  
  /*
   * LOCKMODE is an integer (1..N) indicating a lock type.  LOCKMASK is a bit
***************
*** 363,368 **** typedef struct PROCLOCK
--- 364,371 ----
  
  	/* data */
  	LOCKMASK	holdMask;		/* bitmask for lock types currently held */
+ 	LOCKMASK	holdMaskByAutoTX[MAX_AUTOX_NESTING_LEVEL];	/* bitmask for lock types currently held by autonomous TX */
+ 	LOCKMASK    holdMaskByNormalTX;
  	LOCKMASK	releaseMask;	/* bitmask for lock types to be released */
  	SHM_QUEUE	lockLink;		/* list link in LOCK's list of proclocks */
  	SHM_QUEUE	procLink;		/* list link in PGPROC's list of proclocks */
*** a/src/include/storage/proc.h
--- b/src/include/storage/proc.h
***************
*** 141,146 **** struct PGPROC
--- 141,148 ----
  	bool		fpVXIDLock;		/* are we holding a fast-path VXID lock? */
  	LocalTransactionId fpLocalTransactionId;	/* lxid for fast-path VXID
  												 * lock */
+ 
+ 	uint8 inAutoTXLevel;
  };
  
  /* NOTE: "typedef struct PGPROC PGPROC" appears in storage/lock.h. */
***************
*** 148,153 **** struct PGPROC
--- 150,156 ----
  
  extern PGDLLIMPORT PGPROC *MyProc;
  extern PGDLLIMPORT struct PGXACT *MyPgXact;
+ extern PGDLLIMPORT struct PGAutonomousXACT *MyPgAutonomousXact;
  
  /*
   * Prior to PostgreSQL 9.2, the fields below were stored as part of the
***************
*** 176,181 **** typedef struct PGXACT
--- 179,196 ----
  	uint8		nxids;
  } PGXACT;
  
+ typedef struct PGAutonomousXACT
+ {
+ 	TransactionId   xid;
+ 	TransactionId   xmin;
+ 
+ 	int			nestingLevel;	/* transaction nesting depth */
+ 	struct XidCache subxids;    /* cache for subtransaction XIDs */
+ 	bool		overflowed;
+ 	bool		delayChkpt;		/* true if this proc delays checkpoint start*/
+ 	uint8		 nxids;         /* number of subtransactions */
+ } PGAutonomousXACT;
+ 
  /*
   * There is one ProcGlobal struct for the whole database cluster.
   */
***************
*** 185,190 **** typedef struct PROC_HDR
--- 200,209 ----
  	PGPROC	   *allProcs;
  	/* Array of PGXACT structures (not including dummies for prepared txns) */
  	PGXACT	   *allPgXact;
+ 
+ 	/* Array of PGAutonomous transaction structure*/
+ 	PGAutonomousXACT *allPgAutonomousXact;
+ 
  	/* Length of allProcs array */
  	uint32		allProcCount;
  	/* Head of list of free PGPROC structures */
***************
*** 256,259 **** extern void LockErrorCleanup(void);
--- 275,280 ----
  extern void ProcWaitForSignal(void);
  extern void ProcSendSignal(int pid);
  
+ extern PGAutonomousXACT *GetCurrentPGAutonomousXACT(void);
+ 
  #endif   /* PROC_H */
*** a/src/include/storage/procarray.h
--- b/src/include/storage/procarray.h
***************
*** 25,30 **** extern void ProcArrayAdd(PGPROC *proc);
--- 25,31 ----
  extern void ProcArrayRemove(PGPROC *proc, TransactionId latestXid);
  
  extern void ProcArrayEndTransaction(PGPROC *proc, TransactionId latestXid);
+ extern void ProcArrayEndAutonomousTransaction(PGPROC *proc, TransactionId latestXid);
  extern void ProcArrayClearTransaction(PGPROC *proc);
  
  extern void ProcArrayInitRecovery(TransactionId initializedUptoXID);
***************
*** 79,88 **** extern void XidCacheRemoveRunningXids(TransactionId xid,
  						  int nxids, const TransactionId *xids,
  						  TransactionId latestXid);
  
  extern void ProcArraySetReplicationSlotXmin(TransactionId xmin,
  							TransactionId catalog_xmin, bool already_locked);
  
  extern void ProcArrayGetReplicationSlotXmin(TransactionId *xmin,
  											TransactionId *catalog_xmin);
- 
  #endif   /* PROCARRAY_H */
--- 80,92 ----
  						  int nxids, const TransactionId *xids,
  						  TransactionId latestXid);
  
+ extern void XidCacheRemoveAutoRunningXids(TransactionId xid,
+ 						  int nxids, const TransactionId *xids,
+ 						  TransactionId latestXid, bool isTopAutoTX);
+ 
  extern void ProcArraySetReplicationSlotXmin(TransactionId xmin,
  							TransactionId catalog_xmin, bool already_locked);
  
  extern void ProcArrayGetReplicationSlotXmin(TransactionId *xmin,
  											TransactionId *catalog_xmin);
  #endif   /* PROCARRAY_H */
*** a/src/include/storage/sinval.h
--- b/src/include/storage/sinval.h
***************
*** 142,148 **** extern void EnableCatchupInterrupt(void);
  extern bool DisableCatchupInterrupt(void);
  
  extern int xactGetCommittedInvalidationMessages(SharedInvalidationMessage **msgs,
! 									 bool *RelcacheInitFileInval);
  extern void ProcessCommittedInvalidationMessages(SharedInvalidationMessage *msgs,
  									 int nmsgs, bool RelcacheInitFileInval,
  									 Oid dbid, Oid tsid);
--- 142,148 ----
  extern bool DisableCatchupInterrupt(void);
  
  extern int xactGetCommittedInvalidationMessages(SharedInvalidationMessage **msgs,
! 									 bool *RelcacheInitFileInval, bool isAutoXact);
  extern void ProcessCommittedInvalidationMessages(SharedInvalidationMessage *msgs,
  									 int nmsgs, bool RelcacheInitFileInval,
  									 Oid dbid, Oid tsid);
*** a/src/include/utils/catcache.h
--- b/src/include/utils/catcache.h
***************
*** 174,179 **** extern HeapTuple SearchCatCache(CatCache *cache,
--- 174,183 ----
  			   Datum v3, Datum v4);
  extern void ReleaseCatCache(HeapTuple tuple);
  
+ extern HeapTuple SearchSystableForAutoX(CatCache *cache, Datum v1, Datum v2,
+ 											Datum v3, Datum v4);
+ extern void ReleaseHeapTupleforAutoX(HeapTuple tuple);
+ 
  extern uint32 GetCatCacheHashValue(CatCache *cache,
  					 Datum v1, Datum v2,
  					 Datum v3, Datum v4);
*** a/src/include/utils/inval.h
--- b/src/include/utils/inval.h
***************
*** 33,38 **** extern void AtEOXact_Inval(bool isCommit);
--- 33,40 ----
  
  extern void AtEOSubXact_Inval(bool isCommit);
  
+ extern void AtEOAutoXact_Inval(bool isCommit);
+ 
  extern void AtPrepare_Inval(void);
  
  extern void PostPrepare_Inval(void);
*** a/src/include/utils/portal.h
--- b/src/include/utils/portal.h
***************
*** 194,199 **** typedef struct PortalData
--- 194,200 ----
  /* Prototypes for functions in utils/mmgr/portalmem.c */
  extern void EnablePortalManager(void);
  extern bool PreCommit_Portals(bool isPrepare);
+ extern bool AutoPreCommit_Portals(uint32 createSubid);
  extern void AtAbort_Portals(void);
  extern void AtCleanup_Portals(void);
  extern void AtSubCommit_Portals(SubTransactionId mySubid,
*** a/src/include/utils/resowner.h
--- b/src/include/utils/resowner.h
***************
*** 78,82 **** extern void RegisterResourceReleaseCallback(ResourceReleaseCallback callback,
--- 78,83 ----
  								void *arg);
  extern void UnregisterResourceReleaseCallback(ResourceReleaseCallback callback,
  								  void *arg);
+ extern uint8 GetCurrentResourceOwnerAutoTXLevel(void);
  
  #endif   /* RESOWNER_H */
